class BeaconList extends Info;

var BeaconList Next, Previous;

simulated function Delete()
{
	Next.Previous = Previous;
	Previous.Next = Next;
	
	Destroy();
}

function int ListSize(optional bool bForwardOnly)
{
	if ( bForwardOnly || Previous == None )
	{
		if ( Next == None )
			return 1;
			
		else
			return Next.ListSize() + 1;
	}
	
	if ( Previous.Previous != None )
		return Previous.ListSize();
		
	else
		return Previous.ListSize(true);
}

simulated function BeaconList AddBeacon(Pawn Other)
{
	if ( Other == Owner )
		return self;

	if ( Next != None )
		return Next.AddBeacon(Other);

	Next = Spawn(class'BeaconList', Other);
	
	return Next;
}

function bool RecurseCheck(Pawn Other)
{
	if ( Other == Owner )
		return true;
	
	if ( Next != None )
		return Next.RecurseCheck(Other);
		
	return false;
}

function bool CheckBeacon(Pawn Other)
{
	if ( Previous != None )
		return Previous.CheckBeacon(Other);
		
	return RecurseCheck(Other);
}

function BeaconList RecurseFind(Pawn Other)
{
	if ( Other == Owner )
		return self;
	
	if ( Next != None )
		return Next.RecurseFind(Other);
		
	return None;
}

function BeaconList FindBeacon(Pawn Other)
{
	if ( Previous != None )
		return Previous.FindBeacon(Other);
		
	return RecurseFind(Other);
}

function BeaconList ListHead()
{
	if ( Next != None )
		Return Next.ListHead();
		
	return self;
}

defaultproperties
{
	bStatic=false
	bNoDelete=false
}