//=============================================================================
// BouncingPlasmaSphere.
//=============================================================================
class BouncingPlasmaSphere expands PlasmaSphere;

var()	int		MaxBounces;
var		int		Bounces;
var()	float	BounceFactor, BounceAngle;

function Rotator RotatorSlerp(Rotator a, Rotator b, float f)
{
    return a + (b - a) * f;
}

function bool CanBounce(vector HitLocation, vector HitNormal)
{
	if ( Bounces < MaxBounces )
		Bounces++;

	return Bounces - 1 < MaxBounces;
}

simulated function Explode(vector HitLocation, vector HitNormal)
{
	if ( !CanBounce(HitLocation, HitNormal) )
		Super.Explode(HitLocation, HitNormal);

	Velocity = Normal(Vector(RotatorSlerp(Rotator(Normal(Velocity)), Rotator(Normal(HitNormal)), BounceAngle))) * VSize(Velocity) * BounceFactor;
	SetRotation(Rotator(Normal(Velocity)));
}

defaultproperties
{
     MaxBounces=5
     BounceFactor=0.900000
     BounceAngle=0.800000
}
