//=============================================================================
// BreadcrumbPath.
//=============================================================================
class BreadcrumbPath expands Actor;

var		BreadcrumbPath	Next;
var		BreadcrumbPath	TempNext;
var		BreadcrumbPath	Opt;
var		Breadcrumb		Destination;
var		int				Size;

var()	bool			bNoPathLaser, bShowDir;

function BreadcrumbPath DeletePath()
{
	local BreadcrumbPath P;

	for ( P = self; P != None; P = P.Next )
		P.Destroy();

	Destroy();

	return Next;
}

function int AddPath(BreadcrumbPath Other, optional bool bTemp)
{
	local BreadcrumbPath BP;

	BP = self;

	while ( true )
	{
		if ( BP.Next != none )
			BP = BP.Next;
	
		else break;
	}

	if ( bTemp )
		BP.TempNext = Other;

	else
	{
		BP.Next = Other;

		Size += Other.PathSize();
	}

	return Size;
}

function AddOpt(BreadcrumbPath Other)
{
	local BreadcrumbPath BP;

	for ( BP = self; BP.Opt != None; BP = BP.Opt )
		continue;

	BP.Opt = Other;
}

function int PathSize()
{
	local BreadcrumbPath BP;

	Size = 0;

	for ( BP = self; BP != None; BP = BP.Next )
		Size++;

	return Size;
}

function ControlEntrance(Pawn Other, Breadcrumb Destination);

function BreadcrumbPath SegmentWithBreadcrumb(Breadcrumb Target)
{
	local BreadcrumbPath Current;

	for ( Current = self; Current.Next != None; Current = Current.Next )
		if ( Breadcrumb(Current.Owner) == Target )
			return Current;

	return None;
}

function PostBeginPlay()
{
	SetTimer(2, true);
}

function Timer()
{
	local BPLaser L;

	if ( Owner == None || Destination == None )
	{	
		Destroy();

		return;
	}

	if ( bShowDir )
	{
		L = Owner.Spawn(class'BPLaser', self);

		L.Velocity = Vector(L.Rotation) * (VSize(Owner.Location) + 48) - Owner.Location * 0.2;
		L.SetRotation(Rotator(L.Velocity));
		L.SetTimer(0.2, false);

		bShowDir = false;
	}

	if ( !bNoPathLaser )
	{
		L = Owner.Spawn(class'BPLaser', self);

		L.T = Destination;

		L.Velocity = (Destination.Location - Owner.Location) * 0.5;
		L.SetRotation(Rotator(L.Velocity));
	}
}

defaultproperties
{
     bNoPathLaser=True
     bHidden=True
     Sprite=Texture'Engine.S_Actor'
     Texture=None
     DrawScale=0.250000
     LightSaturation=204
     bCorona=True
}
