//=============================================================================
// ControllerNode.
//=============================================================================
class ControllerNode expands MonsterControllerInfo;

var		ControllerInstance			StartingInstance;
var()	class<ControllerInstance>	InstanceClass;

static function ParseEvent(name EventType, ScriptedPawn Other, MonsterController Controller, class<ControllerEventDetector> Detector)
{
	local ControllerInstance Instance;
	local ControllerInstance OldInstance;

	for ( Instance = default.StartingInstance; True; Instance = Instance.Next )
	{
		if ( Instance.Other == Other && Instance.Node == default.class )
			break;

		if ( Instance == None )
		{
			Instance = Controller.Spawn(default.InstanceClass);
			Instance.Other = Other;
			Instance.Node = default.class;

			Instance.Previous = OldInstance;
			OldInstance.Next = Instance;

			break;
		}

		OldInstance = Instance;
	}
	
	Instance.ParseEvent(EventType, Other, Detector, Controller);

	StaticParseEvent(EventType, Other, Controller, Detector, Instance);
}

static function StaticParseEvent(name EventType, ScriptedPawn Other, MonsterController Controller, class<ControllerEventDetector> Detector, ControllerInstance Instance);

defaultproperties
{
}
