//=============================================================================
// CustomIterator.
//=============================================================================
class CustomIterator expands Info;

struct Iteration
{
	var	bool	bContinue;
	var	Object	Result;
};

var	int		MaxIter, MinIter, IterNum;
var	bool	bIterating;

function Iteration Next(out Object Result, Object Caller, int StartIter)
{
	local Iteration i;

	IterNum++;

	i.bContinue = MaxIter > IterNum && IterNum > MinIter;

	default.IterNum += 1;

	if ( !i.bContinue )
		return i;

	else
	{
		Result = NextResult(StartIter, Caller);
		i.Result = Result;

		return i;
	}
}

function Object NextResult(int StartIter, Object Caller);

function StopIter(int StartIter)
{
	IterNum = 0;
	MaxIter = 0;
	MinIter = 0;
	bIterating = False;
}

function bool Start(int StartIter, int MaxIter, int MinIter)
{
	return True;
}

function bool Iterate(Object Caller, out Object Result, bool bCondition, int StartIter, int MaxIter, int MinIter)
{
	if ( bIterating )
	{
		if ( !Next(Result, Caller, StartIter).bContinue || !bCondition )
		{
			StopIter(StartIter);
			SetTimer(0.1, false);

			return False;
		}

		return True;
	}

	if ( !Start(StartIter, MaxIter, MinIter) || !bCondition )
		return False;

	self.MinIter = MinIter;
	self.MaxIter = MaxIter;
	IterNum	= StartIter;
	bIterating = True;
}

function Timer()
{
	Destroy();
}

defaultproperties
{
}
