class HateList extends Info;

var HateList Next, Previous, First;
var Pawn Victim;
var int Position;

simulated function PostBeginPlay()
{
	Super.PostBeginPlay();

	if ( Previous == None )
	{
		Position = 1;
		First = self;
	}
}

simulated function Delete()
{
	Next.Previous = Previous;
	Previous.Next = Next;
	
	Destroy();
}

function int ListSize(optional bool bForwardOnly)
{
	if ( bForwardOnly || Previous == None )
	{
		if ( Next == None )
			return 1;
			
		else
			return Next.ListSize() + 1;
	}
	
	if ( Previous.Previous != None )
		return Previous.ListSize();
		
	else
		return Previous.ListSize(true);
}

simulated function HateList AddHate(Pawn Other, Pawn InstigatedBy)
{
	if ( Victim == Other && Owner == InstigatedBy )
	{
		// Log("#3#"$self@"O("$Other$") I("$InstigatedBy$")");
	
		return self;
	}

	if ( Next != None )
		return Next.AddHate(Other, InstigatedBy);
		
	Next = Spawn(class'HateList', InstigatedBy);
	Next.Victim = Other;
	Next.First = First;
	Next.Position = Position++;
	Next.Previous = self;
	
	// Log(self@">"@Next);
	
	return Next;
}

function HateList ListTail()
{
	return First; // trusting here
}

function HateList ListHead()
{
	if ( Next != None && Next.Position > Position )
		return Next.ListHead();
		
	return self;
}

function HateList RecurseCheck(Pawn InstigatedBy, Pawn Other)
{
	if ( InstigatedBy == Owner && Other == Victim )
		return self;

	if ( Next != None && Next.Position > Position )
	{
		Log(self@">>>"@next);
		return Next.RecurseCheck(InstigatedBy, Other);
	}
		
	return None;
}

function HateList CheckHate(Pawn InstigatedBy, Pawn Other)
{
	if ( Previous != None )
		return Previous.CheckHate(InstigatedBy, Other);
		
	return RecurseCheck(InstigatedBy, Other);
}

defaultproperties
{
	bStatic=false
	bNoDelete=false
	CollisionRadius=0
	CollisionHeight=0
	bCollideActors=false
	bBlockActors=false
	bBlockPlayers=false
}