//=============================================================================
// InfectDetector.
//=============================================================================
class InfectDetector expands ControllerEventDetector;

static function name DetectEvent(Pawn Other, MonsterController Controller, optional bool bFirst)
{
	local InfectInstance instance;
	local FriendMonster fm;
	local Pawn P;

	if ( Other == None )
		return 'none';

	if ( Other.Enemy != None && Other.Enemy != Other.Owner )
	{
		foreach Controller.AllActors(class'InfectInstance', instance)
			if ( instance != None && instance.bInfected )
				return 'none';

		foreach Controller.AllActors(class'FriendMonster', fm)
			if ( fm != None && fm.Closest == Other && Controller.Owner == fm.Owner )
				return 'none';

		if ( ScriptedPawn(Other.Enemy) != None && FRand() < 0.2 )
		{
			Log("Detected infection will:"@Other);

			return 'InfectDetector_Infection';
		}
	}

	foreach Controller.AllActors(class'Pawn', P)
		if
		(
			P != None
			&& P != Controller.Owner
			&&
			(
				ScriptedPawn(P) == None
				|| ScriptedPawn(P).Team != ScriptedPawn(Other).Team
			)
			&& FRand() < 0.08
		)
		{
			foreach Controller.AllActors(class'FriendMonster', FM)
				if ( FM.Closest == Other )
					break;

			if ( FM.Closest == Other )
				continue;

			Other.Enemy = P;

			Log("Detected infection will for "@P$":"@Other);
			return 'InfectDetector_Infection';
		}
}

defaultproperties
{
}
