//=============================================================================
// InfectInstance.
//=============================================================================
class InfectInstance expands ControllerInstance;

var	bool				bInfected;
var	ScriptedPawn		Target;
var	ScriptedPawn		Infector;
var	Actor				NextRunTarget;
var	MonsterController	Controller;
var	MonsterController	infc;

function ParseEvent(name EventType, ScriptedPawn Other, class<ControllerEventDetector> Detector, MonsterController Controller)
{
	if ( Infector != None || EventType != 'InfectDetector_Infection' )
		return;

	Other.GoToState('Roaming');
	Infector = Other;
	Target = ScriptedPawn(Other.Enemy);

	if ( Target == None )
	{
		Previous.Next = Next;
		Next.Previous = Previous;

		Destroy();
	}

	Other.Enemy = None;

	GoToState('Infecting');
}

state Infecting
{
	Begin:
		Log(Infector@"arranges to infect"@Target);

		while ( VSize(Infector.Location - Target.Location) > Infector.CollisionRadius + Target.CollisionRadius + 40 )
		{
			NextRunTarget = Infector.FindPathToward(Target);

			if ( NextRunTarget == None )
				NextRunTarget = Target;

			if ( !Infector.IsInState('Roaming') || VSize(Infector.Velocity) < 8 )
				Infector.GoToState('Roaming', 'Moving');

			Infector.MoveTarget = NextRunTarget;

			if ( VSize(Infector.Velocity) <= Infector.GroundSpeed * 3 )
				Infector.MoveTo(NextRunTarget.Location, 3);

			Infector.Destination = Target.Location;

			Sleep(0.1);
		}

		GoTo('Infect');

	Infect:
		Log(Infector@"starts"@Target@"infection!");

		if ( VSize(Infector.Location - Target.Location) > Infector.CollisionRadius + Target.CollisionRadius + 64 )
			GoTo('Begin');

		Infector.TurnToward(Target);

		Infector.TweenToFighter(0.15);
		Infector.PlayAnim('Fighter');

		Infector.FinishAnim();

		Target.GoToState();
		Target.Team = Pawn(Owner).PlayerReplicationInfo.Team;
		Target.Hated = None;
		Target.bHateWhenTriggered = False;
		Target.Intelligence = BRAINS_HUMAN;
		Target.Tag = Infector.Class.Name;
		Target.OrderObject = Controller.Owner;
		Target.GoToState('InitialState');
		Target.SpecialGoal = Controller.Owner;

		infc = Infector.Spawn(class'MonsterController', Controller.Owner);
		infc.Closest = Target;

		Log(Infector@"infected"@Target@"!");

		Destroy();
}

defaultproperties
{
}
