//=============================================================================
// MonsterController.
//=============================================================================
class MonsterController expands FriendMonster;

var()	class<ControllerNode>			EventHandlers[64];
var()	class<ControllerEventDetector>	EventDetectors[64];

function PreBeginPlay()
{
	local int i;

	for ( i = 0; i < 64; i++ )
	{
		if ( EventHandlers[i] == None )
			break;

		log("Using Handler:"@EventHandlers[i]);
	}

	for ( i = 0; i < 64; i++ )
	{
		if ( EventDetectors[i] == None )
			break;

		log("Using Detector:"@EventDetectors[i]);
	}
}

function Timer()
{
	Super.Timer();

	DetectEvents();
}

function DetectEvents()
{
	local	int		i;
	local	int		j;
	local	name	n;

	for ( i = 0; i < 64; i++ )
	{
		if ( EventDetectors[i] == None )
			break;

		n = EventDetectors[i].static.DetectEvent(Closest, self);

		if ( n != 'None' )
		{
			log("Got Controller Event from"@EventDetectors[i]@"for Pawn"@Closest@"with controller"@self$":"@n);

			for ( j = 0; j < 64; j++ )
			{
				if ( EventHandlers[j] == None )
					break;

				EventHandlers[j].static.ParseEvent(n, Closest, self, EventDetectors[i]);
			}
		}
	}
}

defaultproperties
{
     EventHandlers(0)=Class'GusPackII.InfectNode'
     EventDetectors(0)=Class'GusPackII.InfectDetector'
}
