#exec mesh import mesh=MBeaconWeap anivfile=Models\MBeaconWeap_a.3d datafile=Models\MBeaconWeap_d.3d x=0 y=0 z=0 mlod=1

#exec mesh sequence mesh=MBeaconWeap seq=All startframe=0 numframes=37 rate=19
#exec mesh sequence mesh=MBeaconWeap seq=Still startframe=0 numframes=1 rate=1
#exec mesh sequence mesh=MBeaconWeap seq=Fire startframe=0 numframes=16 rate=18
#exec mesh sequence mesh=MBeaconWeap seq=Down startframe=16 numframes=9 rate=28
#exec mesh sequence mesh=MBeaconWeap seq=Select startframe=25 numframes=12 rate=21

#exec meshmap new meshmap=MBeaconWeap mesh=MBeaconWeap
#exec meshmap scale meshmap=MBeaconWeap x=0.1 y=0.1 z=0.2

#exec texture import name=JMBeaconWeap file=Textures\JMBeaconWeap.pcx group=Skins
#exec meshmap settexture meshmap=MBeaconWeap num=0 texture=JMBeaconWeap

class MushBeacon extends TournamentWeapon;


function Projectile ProjectileFire(class<projectile> ProjClass, float ProjSpeed, bool bWarn)
{
	local Projectile pj;
	
	FireOffset.X += 15;
	
	while ( pj == None )
	{
		FireOffset.X -= 15;
	
		if ( FireOffset.X < -20 )
			return None;
		
		pj = Super.ProjectileFire(ProjClass, ProjSpeed, bWarn);
	}
	
	FireOffset.X = Default.FireOffset.X;
	
	pj.Instigator = Pawn(Owner);
	
	return pj;
}

simulated function Tick(float TimeDelta)
{
	local Pawn p;
	
	Super.Tick(TimeDelta);
		
	if ( Owner == None || Owner.IsInState('Dying') || ( MushMatch(Level.Game) == none && Pawn(Owner).PlayerReplicationInfo != none && Pawn(Owner).PlayerReplicationInfo.Deaths > 0 ) )
	{
		Destroy();
		return;
	}
}

simulated function float RateSelf(out int bUseAltMode)
{
	local Pawn P;
	local float Score, BestScore;
	local Pawn BestPawn;
	
	Score = -50;
	
	if ( Pawn(Owner).Enemy != None && Pawn(Owner).Enemy.FindInventoryType(class'GusPackII.SpottedMush') != None )
		return -50000;
	
	bUseAltMode = 0;
	
	if ( MushMatch(Level.Game).Hates != None )
		for ( P = Level.PawnList; P != None; P = P.NextPawn )
			if ( MushMatch(Level.Game).Hates.CheckHate(P, Pawn(Owner)) != None && ( MushMatch(Level.Game).Beacons == None || !MushMatch(Level.Game).Beacons.CheckBeacon(P) ) ) 
			{
				if ( Max(200, 1024 - VSize(Owner.Location - P.Location)) / 4 > BestScore )
				{
					BestScore = Max(200, 1024 - VSize(Owner.Location - P.Location)) / 4;
					BestPawn = P;
				}
				
				Score += Max(200, 1024 - VSize(Owner.Location - P.Location)) / 2;
			}

	if ( BestPawn != None )
		Bot(Owner).SetEnemy(BestPawn);
	
	return Score;
}

function PlayFiring()
{
	PlayAnim('Fire', 1.4, 0.1);
	PlayOwnedSound(FireSound, SLOT_Misc, 1.0);
}

function PlayIdleAnim()
{
	PlayAnim('Still', 0.3, 0.4);
}

defaultproperties
{
	bWarnTarget=false
	bAltWarnTarget=false
	ProjectileClass=class'GusPackII.MushBeaconProj'
	AltProjectileClass=class'GusPackII.MushBeaconProj'
	bInstantHit=false
	Ammoname=class'GusPackII.MushBeaconAmmo'
	PickupAmmoCount=15
	FireSound=Sound'Botpack.BioRifle.GelHit'
	Deathmessage="%k got crazy and killed %o with some Mush Beacon Gun..."
	InventoryGroup=1
	Pickupmessage="You got the Mush Beacon Gun."
	Itemname="Mush Beacon"
	PlayerViewmesh=Lodmesh'GusPackII.MBeaconWeap'
	PickupViewmesh=Lodmesh'GusPackII.MBeaconWeap'
	ThirdPersonmesh=Lodmesh'GusPackII.MBeaconWeap'
	Icon=Texture'Botpack.Icons.IconPulse'
	mesh=Lodmesh'GusPackII.MBeaconWeap'
	PickupSound=Sound'Botpack.enforcer.Cocking'
	SelectSound=Sound'Botpack.enforcer.Cocking'
	maxDesireability=0
	StatusIcon=Texture'Botpack.Icons.UsePulse'
	PlayerViewOffset=(X=65.100000,Y=-35.0000,Z=-19.0000)
	FireOffset=(X=32.00000,Y=0.0000,Z=0.0000)
}
