#exec mesh import mesh=MBeaconProj anivfile=Models\MBeaconProj_a.3d datafile=Models\MBeaconProj_d.3d x=0 y=0 z=0 mlod=1

#exec mesh sequence mesh=MBeaconProj seq=All startframe=0 numframes=30 rate=18
#exec mesh sequence mesh=MBeaconProj seq=Still startframe=0 numframes=1 rate=1
#exec mesh sequence mesh=MBeaconProj seq=Fire startframe=0 numframes=12 rate=18
#exec mesh sequence mesh=MBeaconProj seq=Down startframe=13 numframes=9 rate=18
#exec mesh sequence mesh=MBeaconProj seq=Select startframe=22 numframes=8 rate=18

#exec meshmap new meshmap=MBeaconProj mesh=MBeaconProj
#exec meshmap scale meshmap=MBeaconProj x=0.1 y=0.1 z=0.2

#exec texture import name=JMBeaconProj file=Textures\JMBeaconProj.pcx group=Skins
#exec meshmap settexture meshmap=MBeaconProj num=0 texture=JMBeaconProj

class MushBeaconProj extends Projectile;

simulated function PostBeginPlay()
{
	Super.PostBeginPlay();

	SetPhysics(PHYS_Projectile);
	Velocity = Vector(Rotation) * speed;
}

simulated function ProcessTouch(Actor Other, Vector HitLocation)
{
	if ( Pawn(Other) != None && Pawn(Other).bIsPlayer && MushMatch(Level.Game) != None && Pawn(Other).PlayerReplicationInfo != None && Pawn(Other).PlayerReplicationInfo.Deaths <= 0 && Instigator != Other )
		MushMatch(Level.Game).StrapBeacon(Pawn(Other), Instigator);
}

defaultproperties
{
	Damage=0
	maxSpeed=1600
	Speed=1600
	momentumTransfer=0
	ImpactSound=Sound'Botpack.Pickups.AmmoPick'
	ExplosionDecal=Texture'GusPackII.Decals.SporeDecal'
	mesh=Lodmesh'GusPackII.MBeaconProj'
	CollisionRadius=16
	CollisionHeight=16
	DrawScale=0.45
}