class MushMatchMutator extends DMMutator;

var bool bBeginplayed;

function PostBeginPlay()
{
	if ( bBeginplayed )
		return;
	
	Super.PostBeginPlay();
	
	Level.Game.RegisterDamageMutator(self);
	
	bBeginplayed = true;
}

function bool HandleEndGame()
{
	return true;
}

simulated function MutatorTakeDamage(out int ActualDamage, Pawn Victim, Pawn InstigatedBy, out Vector HitLocation, out Vector Momentum, name DamageType)
{
	local Pawn P;

	if ( InstigatedBy == None || Victim == None || InstigatedBy == Victim )
		return;
	
	for ( P = Level.PawnList; P != None; P = P.NextPawn )
		if ( P != None && P.bIsPlayer && P.PlayerReplicationInfo != None && (!P.IsInState('Dying')) && P != Victim && P != InstigatedBy && P.PlayerReplicationInfo.Deaths <= 0 && P.LineOfSightTo(InstigatedBy) && P.LineOfSightTo(Victim) && P.PlayerReplicationInfo.Team == 0 && ( MushMatch(Level.Game).Hates == None || MushMatch(Level.Game).Hates.CheckHate(InstigatedBy, P) == None ) )
		{
			Log(p.PlayerReplicationInfo.PlayerName@"suspects"@InstigatedBy.PlayerReplicationInfo.PlayerName);
		
			MushMatch(Level.Game).RegisterHate(P, InstigatedBy);
		}

	if ( Victim.LineOfSightTo(InstigatedBy) && Victim.PlayerReplicationInfo.Team == 0 && ( MushMatch(Level.Game).Hates == None || MushMatch(Level.Game).Hates.CheckHate(InstigatedBy, Victim) == None ) )
	{
		Log(Victim.PlayerReplicationInfo.PlayerName@"suspects"@InstigatedBy.PlayerReplicationInfo.PlayerName);
	
		MushMatch(Level.Game).RegisterHate(Victim, InstigatedBy);
	}
		
	if ( NextDamageMutator != None )
		NextDamageMutator.MutatorTakeDamage(ActualDamage, Victim, InstigatedBy, HitLocation, Momentum, DamageType);
}