class MushMatchScoreBoard extends TournamentScoreBoard;

static function string TeamText(PlayerReplicationInfo PRI, LevelInfo Level, PlayerPawn Other)
{
	if ( PRI.Team == 1 && MushMatch(Level.Game).bSelected && ( Other.PlayerReplicationInfo == PRI || Pawn(PRI.Owner).IsInState('Dying') || Other.PlayerReplicationInfo.Team == 1 || MushMatch(Level.Game).bMatchEnd || PRI.Deaths > 0 ) )
	{
		if ( Pawn(PRI.Owner).IsInState('Dying') || PRI.Deaths > 0 )
			return "Mush (dead)";
	
		else if ( MushMatch(Level.Game).Beacons != None && MushMatch(Level.Game).Beacons.CheckBeacon(Pawn(PRI.Owner)) )
			return "Mush (susp.)";
		
		else if ( Pawn(PRI.Owner).FindInventoryType(class'GusPackII.SpottedMush') == none )
			return "Mush (unk.)";
	}
		
	if ( PRI.Team == 0 && MushMatch(Level.Game).bSelected && ( Other.PlayerReplicationInfo == PRI || Pawn(PRI.Owner).IsInState('Dying') || Other.PlayerReplicationInfo.Team == 1 || MushMatch(Level.Game).bMatchEnd || PRI.Deaths > 0 ) )
	{
		if ( Pawn(PRI.Owner).IsInState('Dying') || PRI.Deaths > 0 )
			return "Human (dead)";
			
		else if ( MushMatch(Level.Game).Beacons != None && MushMatch(Level.Game).Beacons.CheckBeacon(Pawn(PRI.Owner)) )
			return "Human (susp.)";
			
		else if ( Pawn(PRI.Owner).FindInventoryType(class'GusPackII.NotMush') != none )
			return "Human (cert)";
		
		else if ( Pawn(PRI.Owner).FindInventoryType(class'GusPackII.NotMush') == None )
			return "Human";
	}
	
	if ( PRI.Team == 0 && MushMatch(Level.Game).bSelected && Pawn(PRI.Owner).FindInventoryType(class'GusPackII.NotMush') != none )
		return "Human (cert)";

	if ( PRI.Team == 1 && MushMatch(Level.Game).bSelected && Pawn(PRI.Owner).FindInventoryType(class'GusPackII.SpottedMush') != none )
		return "Mush!";
	
	if ( MushMatch(Level.Game).Beacons != None && MushMatch(Level.Game).Beacons.FindBeacon(Pawn(PRI.Owner)) != None && MushMatch(Level.Game).Beacons.FindBeacon(Pawn(PRI.Owner)).Instigator.FindInventoryType(class'GusPackII.SpottedMush') == None )
		return "Suspected";
	
	return "Unknown";
}

function DrawNameAndPing(Canvas Canvas, PlayerReplicationInfo PRI, float XOffset, float YOffset, bool bCompressed)
{
	local float XL, YL, XL2, YL2, XL3, YL3;
	
	Super.DrawNameAndPing(Canvas, PRI, XOffset, YOffset, bCompressed);
	
	Canvas.StrLen( "0000000000000000", XL, YL );

	Canvas.StrLen( static.TeamText(PRI, Level, PlayerPawn(Owner)), XL2, YL );
	Canvas.SetPos( Canvas.ClipX * 0.825 + XL * 0.5 - XL2, YOffset );
	Canvas.DrawText( static.TeamText(PRI, Level, PlayerPawn(Owner)), false );
}