class PlayerMonitor extends Actor;


var bool bHuman;

function PostBeginPlay()
{
	if ( Pawn(Owner) == None || !CheckMonitorable(Pawn(Owner)) )
	{
		Warn(self@"has no owner or an unqualified one:"@Owner);
		Destroy();
	
		return;
	}
	
	SetCollisionSize(Owner.CollisionRadius * 0.75, Owner.CollisionHeight * 0.75);
	
	class'AttachInfo'.static.CreateAttachment(Owner, self, 1);
	
	ZoneChange(Region.Zone);
}

function Tick(float TimeDelta)
{
	Super.Tick(TimeDelta);
	
	if ( Pawn(Owner) == None || !CheckMonitorable(Pawn(Owner)) )
	{
		Destroy();
	
		return;
	}
}

function bool CheckMonitorable(Pawn Other)
{
	return ( Other.bIsPlayer && Other.PlayerReplicationInfo != None && ( mushmatch(Level.Game) == None || !mushmatch(Level.Game).bSelected || Other.PlayerReplicationInfo.Deaths <= 0 ) );
}

function ZoneChange(ZoneInfo NewZone)
{
	if ( Pawn(Owner).PlayerReplicationInfo.Team == 1 )
	{
		if ( NewZone.bWaterZone )
			SetTimer(0.5, true);
			
		else
			SetTimer(0.0, false);
	}
	
	else if ( Pawn(Owner).PlayerReplicationInfo.Team == 0 && Pawn(Owner).FindInventoryType(class'NotMush') == none && NewZone.bWaterZone && !bHuman && (!NewZone.bPainZone) )
	{
		SetTimer(0.5, true);
	
		Timer();
	}
	
	else
		SetTimer(0.0, false);
}

function Timer()
{
	local Pawn p;

	if ( !bHuman )
	{
		for ( p = Level.PawnList; p != None; p = p.NextPawn )
			if ( p.bIsPlayer && p != Pawn(Owner) && p.PlayerReplicationInfo != none && p.PlayerReplicationInfo.Deaths <= 0 && p.CanSee(Pawn(Owner)) && p.PlayerReplicationInfo.Team == 0 )
			{
				Pawn(Owner).AddInventory(Spawn(class'NotMush'));
			
				Broadcastmessage(Pawn(Owner).PlayerReplicationInfo.Playername@"was confirmed human by"@p.PlayerReplicationInfo.PlayerName$"!", true, 'CriticalEvent');
				
				SetTimer(0.0, false);
				bHuman = true;
			}
			
			// else Log( p @ Pawn(Owner) @ p.bIsPlayer @ p != Pawn(Owner) @ p.PlayerReplicationInfo != none @ p.PlayerReplicationInfo.Deaths <= 0 @ p.CanSee(Pawn(Owner)) @ p.PlayerReplicationInfo.Team == 0 );
	}
	
	else if ( Pawn(Owner).PlayerReplicationInfo.Team == 1 )
	{
		Pawn(Owner).Health -= 5;
		Pawn(Owner).TakeDamage(5, Pawn(Owner), Owner.Location, vect(0,0,0), 'waterburn');
	}
}

defaultproperties
{
	bStatic=false
	bNoDelete=false
	bBlockPlayers=false
	bBlockActors=false
	DrawType=DT_None
	bCanTeleport=true
}