//=============================================================================
// QuickBotMover.
//=============================================================================
class QuickBotMover expands BotMovers;

var(Pathing)	bool	bResetWalkHeight;

// This class deprecates CenterOffset (and if desired WalkHeight) by using this actor's relative position to the mover instead.

function PreBeginPlay()
{
	local Mover MyMover;
	local Vector Offset;
	local int i;
	local KeyPath KP;

	MyMover = GetMover();

	if ( MyMover == None )
		return;

	LogActor(MyMover);

	Offset = Location - MyMover.Location;

	if ( bResetWalkHeight )
		WalkHeight = Offset.Z;

	CenterOffset = Offset;

	if ( bResetWalkHeight )
		CenterOffset.Z = 0;
	
	for ( i = 0; i < NumPathes; i++ )
	{
		Log(i);

		ProcessPath(MyMover, KeyPathes[i]);

		KP.KeyBegin = KeyPathes[i].KeyOffset;
		KP.KeyOffset = KeyPathes[i].KeyBegin;

		ProcessPath(MyMover, KP);
	}
}

defaultproperties
{
     bResetWalkHeight=True
}
