//=============================================================================
// ShockBounceBall.
//=============================================================================
class ShockBounceBall expands ShockProj;

var()	int		MaxBounces;
var		int		Bounces;
var()	float	BounceFactor, BounceChance, BounceError;
var()	bool	bChanceOverride;

function bool CanBounce(vector HitNormal)
{
	if ( !bChanceOverride )
	{
		if ( Bounces < MaxBounces )
			Bounces++;

		return Bounces - 1 < MaxBounces && FRand() * 100 < BounceChance && BounceChance > 0;
	}

	else
		return FRand() * 100 < BounceChance && BounceChance > 0;
}

auto state() Flying
{
	simulated function HitWall(vector HitNormal, Actor Wall)
	{
		if ( !CanBounce(HitNormal) )
		{
			super.HitWall(HitNormal, Wall);
	
			return;
		}
	
		Wall.TakeDamage(Damage, instigator, Location, MomentumTransfer * Normal(Velocity), MyDamageType);
		Velocity -= 2 * (Velocity dot HitNormal) * HitNormal * BounceFactor * VRand() * BounceError; 
		SetRotation(Rotator(Velocity));

		speed = VSize(Velocity);
	
		log(Velocity);
	}
}

defaultproperties
{
     MaxBounces=32
     BounceFactor=1.375000
     BounceChance=95.000000
     BounceError=16.000000
}
